summaryrefslogtreecommitdiff
path: root/dev-python/numpy
diff options
context:
space:
mode:
authorLiguros - Gitlab CI/CD [develop] <gitlab@liguros.net>2025-09-15 18:59:29 +0000
committerLiguros - Gitlab CI/CD [develop] <gitlab@liguros.net>2025-09-15 18:59:29 +0000
commit459468f49c11794ed867d2ad7055bb716a14c6b2 (patch)
tree56a8ecbd06925156061b23225a438a664d7dafb1 /dev-python/numpy
parent37f3a4a21f3ac9c85846c3abeb389206a079e3ef (diff)
downloadbaldeagleos-repo-459468f49c11794ed867d2ad7055bb716a14c6b2.tar.gz
baldeagleos-repo-459468f49c11794ed867d2ad7055bb716a14c6b2.tar.xz
baldeagleos-repo-459468f49c11794ed867d2ad7055bb716a14c6b2.zip
Adding metadata
Diffstat (limited to 'dev-python/numpy')
-rw-r--r--dev-python/numpy/Manifest2
-rw-r--r--dev-python/numpy/numpy-2.3.0.ebuild199
-rw-r--r--dev-python/numpy/numpy-2.3.2.ebuild2
-rw-r--r--dev-python/numpy/numpy-2.3.3.ebuild (renamed from dev-python/numpy/numpy-2.3.1-r1.ebuild)190
4 files changed, 171 insertions, 222 deletions
diff --git a/dev-python/numpy/Manifest b/dev-python/numpy/Manifest
index 4abd85d2c408..18f38419a41b 100644
--- a/dev-python/numpy/Manifest
+++ b/dev-python/numpy/Manifest
@@ -1,5 +1,5 @@
DIST numpy-1.26.4.tar.gz 15786129 BLAKE2B ee759d3a857111bc494d5e989a7b005375d942b2a89cda69be4a3bd7c6cb195003fd2a8a0535f1858d8977ff688b0ec36360dcba9c3160206eedce5e28f191ef SHA512 f7121ab4099fa0686f9c095d456baa4a5869d651d7b7a06385f885f329cf08f11024b5df5e7b4ee705970062a8102ec4f709512eabbfd5c9fccce4ef83b9c208
DIST numpy-2.2.6.tar.gz 20276440 BLAKE2B 597ebbc72b2b3901bba4e0946f4f63ff13baf3b04d2f44d6e1ce8d05112f5d7191cb2e2f80e20006f0bc57a5a3f395fcc6003d9593e41b057394c12ad44f69f7 SHA512 00c82476c6cc8e68c4cd3210896172d91bdb52a46676931d173a3bbd772b29cebc8e819dfbbaf621eba9225fff3fa3f81426fe864d8812de4ff2975e7ac5c338
-DIST numpy-2.3.0.tar.gz 20382813 BLAKE2B 684eed2d207b633feec03cb7c9517e4dff30033b498e6622448d278f2e3b442fa9f08a30c9d8d74f746d0524b9e4725348ccae10f1f3952df03b72d60af7f5c6 SHA512 d3fdae873fc50a692135045ee7fb542b0206ff167ffbe575a975ace4786b2a2f2d4b52034de3f61653feddffb5a850f5b2a499a32ec5214c0872c20b319d4d65
DIST numpy-2.3.1.tar.gz 20390372 BLAKE2B a52f39f8b7e4cf75bed3bbf32b92be7d118c7bab0b3cdbb1428b24daf71d4813641ade390bb20848156fc0ead3768383f272b755d130fb36348859b8c435c954 SHA512 aedb917cc6d8fcb923edb5b32e8b84bddb31fcf0159cfbda88b7ea9a5bc9e0ef58f27391746c6e9140777daf928c3e9de2a73758555130e5c00725d7082f7c2a
DIST numpy-2.3.2.tar.gz 20489306 BLAKE2B 66a683a62daf3971c01a484d6e8c56e592744b93ec2648b61246d9969b02c62256153fb7c643002d7f82ebf1bfd5c9f34c14449b9daf85007e6cb854e97852dd SHA512 8f315a681704f1a18712828b5b9d5cd602576230fb08ff00c293ce129656faa49c9e01a446989dbd4d678166975432b531915e4838be66655ead1f0fc05be861
+DIST numpy-2.3.3.tar.gz 20576648 BLAKE2B 285c3ea4852618c9a7af339f117b12e06c736a765c6b97437ac8b2c0c02085126a89cc8d6d9e0e6f7d5ebb69d63a972c1619bf6c407197882e01c7cddfb8d79b SHA512 5555f68d75342054c240695a7a7aaaaec09c45e04965b4100732a7f8f49f53a203ec438e35c12040481d6ee9f4649e43c83ac96fdc08526cdcf93463b9fe7bd9
diff --git a/dev-python/numpy/numpy-2.3.0.ebuild b/dev-python/numpy/numpy-2.3.0.ebuild
deleted file mode 100644
index 0107b72d284b..000000000000
--- a/dev-python/numpy/numpy-2.3.0.ebuild
+++ /dev/null
@@ -1,199 +0,0 @@
-# Copyright 1999-2025 Gentoo Authors
-# Distributed under the terms of the GNU General Public License v2
-
-EAPI=8
-
-DISTUTILS_EXT=1
-DISTUTILS_USE_PEP517=meson-python
-PYTHON_COMPAT=( python3_{9,10,11,12,13} pypy3 )
-PYTHON_REQ_USE="threads(+)"
-FORTRAN_NEEDED=lapack
-
-inherit distutils-r1 flag-o-matic fortran-2 pypi
-
-DESCRIPTION="Fast array and numerical python library"
-HOMEPAGE="
- https://numpy.org/
- https://github.com/numpy/numpy/
- https://pypi.org/project/numpy/
-"
-
-LICENSE="BSD"
-SLOT="0/2"
-KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86"
-# +lapack because the internal fallbacks are pretty slow. Building without blas
-# is barely supported anyway, see bug #914358.
-IUSE="big-endian +lapack"
-
-RDEPEND="
- lapack? (
- >=virtual/cblas-3.8
- >=virtual/lapack-3.8
- )
-"
-BDEPEND="
- ${RDEPEND}
- >=dev-build/meson-1.5.2
- >=dev-python/cython-3.0.6[${PYTHON_USEDEP}]
- lapack? (
- virtual/pkgconfig
- )
- test? (
- $(python_gen_cond_dep '
- >=dev-python/cffi-1.14.0[${PYTHON_USEDEP}]
- ' 'python*')
- dev-python/charset-normalizer[${PYTHON_USEDEP}]
- >=dev-python/hypothesis-5.8.0[${PYTHON_USEDEP}]
- dev-python/pytest-rerunfailures[${PYTHON_USEDEP}]
- dev-python/pytest-timeout[${PYTHON_USEDEP}]
- >=dev-python/pytz-2019.3[${PYTHON_USEDEP}]
- )
-"
-
-QA_CONFIG_IMPL_DECL_SKIP=(
- # https://bugs.gentoo.org/925367
- vrndq_f32
-)
-
-EPYTEST_XDIST=1
-distutils_enable_tests pytest
-
-python_prepare_all() {
- local PATCHES=(
- # https://github.com/google/highway/issues/2577
- # github.com/google/highway/commit/7cde540171a1718a9bdfa8f896d70e47eb0785d5
- "${FILESDIR}/${PN}-2.2.6-gcc16.patch"
- )
-
- # bug #922457
- filter-lto
- # https://github.com/numpy/numpy/issues/25004
- append-flags -fno-strict-aliasing
-
- distutils-r1_python_prepare_all
-}
-
-python_configure_all() {
- DISTUTILS_ARGS=(
- -Dallow-noblas=$(usex !lapack true false)
- -Dblas=$(usev lapack cblas)
- -Dlapack=$(usev lapack lapack)
- # TODO: cpu-* options
- )
-}
-
-python_test() {
- # don't run tests that require more than 4 GiB of RAM (per process)
- local -x NPY_AVAILABLE_MEM="4 GiB"
-
- local EPYTEST_DESELECT=(
- # Very disk-and-memory-hungry
- numpy/lib/tests/test_io.py::TestSavezLoad::test_closing_fid
- numpy/lib/tests/test_io.py::TestSavezLoad::test_closing_zipfile_after_load
-
- # Precision problems
- numpy/_core/tests/test_umath_accuracy.py::TestAccuracy::test_validate_transcendentals
-
- numpy/typing/tests/test_typing.py
- )
-
- if [[ $(uname -m) == armv8l ]]; then
- # Degenerate case of arm32 chroot on arm64, bug #774108
- EPYTEST_DESELECT+=(
- numpy/_core/tests/test_cpu_features.py::Test_ARM_Features::test_features
- )
- fi
-
- case ${ARCH} in
- arm)
- EPYTEST_DESELECT+=(
- # TODO: warnings
- numpy/_core/tests/test_umath.py::TestSpecialFloats::test_unary_spurious_fpexception
-
- # TODO
- numpy/_core/tests/test_function_base.py::TestLinspace::test_denormal_numbers
- numpy/f2py/tests/test_kind.py::TestKind::test_real
- numpy/f2py/tests/test_kind.py::TestKind::test_quad_precision
-
- # require too much memory
- 'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[complex128]'
- 'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[float64]'
- )
- ;;
- hppa)
- EPYTEST_DESELECT+=(
- # https://bugs.gentoo.org/942689
- "numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype[int]"
- "numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype[float]"
- "numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[datetime64]"
- "numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[timedelta64]"
- "numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[<f]"
- "numpy/_core/tests/test_dtype.py::TestPickling::test_pickle_dtype[dt28]"
- numpy/f2py/tests/test_kind.py::TestKind::test_real
- numpy/f2py/tests/test_kind.py::TestKind::test_quad_precision
- numpy/tests/test_ctypeslib.py::TestAsArray::test_reference_cycles
- numpy/tests/test_ctypeslib.py::TestAsArray::test_segmentation_fault
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_scalar
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_subarray
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_structure
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_structure_aligned
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_union
- numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_padded_union
- )
- ;;
- ppc|x86)
- EPYTEST_DESELECT+=(
- # require too much memory
- 'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[complex128]'
- 'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[float64]'
- )
- ;;
- esac
-
- if [[ ${CHOST} == powerpc64le-* ]]; then
- EPYTEST_DESELECT+=(
- # long double thingy
- numpy/_core/tests/test_scalarprint.py::TestRealScalars::test_ppc64_ibm_double_double128
- )
- fi
-
- if use big-endian; then
- EPYTEST_DESELECT+=(
- # ppc64 and sparc
- numpy/linalg/tests/test_linalg.py::TestDet::test_generalized_sq_cases
- numpy/linalg/tests/test_linalg.py::TestDet::test_sq_cases
- "numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f77[s1]"
- "numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f77[t1]"
- "numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f90[s1]"
- "numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f90[t1]"
- )
- fi
-
- if ! has_version -b "~${CATEGORY}/${P}[${PYTHON_USEDEP}]" ; then
- # depends on importing numpy.random from system namespace
- EPYTEST_DESELECT+=(
- 'numpy/random/tests/test_extending.py::test_cython'
- )
- fi
-
- if has_version ">=dev-python/setuptools-74[${PYTHON_USEDEP}]"; then
- # msvccompiler removal
- EPYTEST_DESELECT+=(
- numpy/tests/test_public_api.py::test_all_modules_are_expected_2
- numpy/tests/test_public_api.py::test_api_importable
- )
- EPYTEST_IGNORE+=(
- numpy/distutils/tests/test_mingw32ccompiler.py
- numpy/distutils/tests/test_system_info.py
- )
- fi
-
- local -x PYTEST_DISABLE_PLUGIN_AUTOLOAD=1
- cd "${BUILD_DIR}/install$(python_get_sitedir)" || die
- epytest -p rerunfailures --reruns=5
-}
-
-python_install_all() {
- local DOCS=( LICENSE.txt README.md THANKS.txt )
- distutils-r1_python_install_all
-}
diff --git a/dev-python/numpy/numpy-2.3.2.ebuild b/dev-python/numpy/numpy-2.3.2.ebuild
index 712395df1b0c..269250c65b43 100644
--- a/dev-python/numpy/numpy-2.3.2.ebuild
+++ b/dev-python/numpy/numpy-2.3.2.ebuild
@@ -20,7 +20,7 @@ HOMEPAGE="
LICENSE="BSD"
SLOT="0/2"
-KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ppc64 ~riscv ~s390 ~sparc ~x86"
+KEYWORDS="~alpha ~amd64 ~arm arm64 ~hppa ~loong ~m68k ~mips ~ppc ppc64 ~riscv ~s390 ~sparc ~x86"
# +lapack because the internal fallbacks are pretty slow. Building without blas
# is barely supported anyway, see bug #914358.
IUSE="big-endian +lapack"
diff --git a/dev-python/numpy/numpy-2.3.1-r1.ebuild b/dev-python/numpy/numpy-2.3.3.ebuild
index c2f460bee39c..59ba10bc6dbe 100644
--- a/dev-python/numpy/numpy-2.3.1-r1.ebuild
+++ b/dev-python/numpy/numpy-2.3.3.ebuild
@@ -23,7 +23,21 @@ SLOT="0/2"
KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86"
# +lapack because the internal fallbacks are pretty slow. Building without blas
# is barely supported anyway, see bug #914358.
-IUSE="big-endian +lapack"
+IUSE="big-endian +cpudetection +lapack"
+
+# upstream-flag[:gentoo-flag]
+ARM_FLAGS=( neon{,-fp16} vfpv4 asimd{,hp,dp,fhm} sve )
+PPC_FLAGS=( vsx vsx2 vsx3 vsx4 )
+X86_FLAGS=(
+ sse{,2,3,4_1,4_2} ssse3 popcnt avx{,2} xop fma{3,4}
+ f16c avx512{f,cd,pf,er,dq,bw,vl,ifma,vbmi}
+ avx512_{vpopcntdq,4vnniw,4fmaps,vbmi2,bitalg,fp16,vnni}
+)
+IUSE+="
+ ${ARM_FLAGS[*]/#/cpu_flags_arm_}
+ ${PPC_FLAGS[*]/#/cpu_flags_ppc_}
+ ${X86_FLAGS[*]/#/cpu_flags_x86_}
+"
RDEPEND="
lapack? (
@@ -43,9 +57,6 @@ BDEPEND="
>=dev-python/cffi-1.14.0[${PYTHON_USEDEP}]
' 'python*')
dev-python/charset-normalizer[${PYTHON_USEDEP}]
- >=dev-python/hypothesis-5.8.0[${PYTHON_USEDEP}]
- dev-python/pytest-rerunfailures[${PYTHON_USEDEP}]
- dev-python/pytest-timeout[${PYTHON_USEDEP}]
>=dev-python/pytz-2019.3[${PYTHON_USEDEP}]
)
"
@@ -55,33 +66,166 @@ QA_CONFIG_IMPL_DECL_SKIP=(
vrndq_f32
)
+EPYTEST_PLUGINS=( hypothesis pytest-timeout )
EPYTEST_XDIST=1
distutils_enable_tests pytest
-python_prepare_all() {
- local PATCHES=(
- # https://github.com/google/highway/issues/2577
- # github.com/google/highway/commit/7cde540171a1718a9bdfa8f896d70e47eb0785d5
- "${FILESDIR}/${PN}-2.2.6-gcc16.patch"
- # https://github.com/numpy/numpy/pull/29392
- "${FILESDIR}/${PN}-2.3.1-fix-vector.patch"
- )
-
- # bug #922457
- filter-lto
- # https://github.com/numpy/numpy/issues/25004
- append-flags -fno-strict-aliasing
+PATCHES=(
+ # https://github.com/numpy/numpy/pull/29459
+ "${FILESDIR}"/${PN}-2.3.2-no-detect.patch
+ # https://github.com/numpy/numpy/pull/29579
+ "${FILESDIR}"/${PN}-2.3.2-arm-asimddp.patch
+)
- distutils-r1_python_prepare_all
+has_all_x86() {
+ local flag
+ for flag; do
+ if ! use "cpu_flags_x86_${flag}"; then
+ return 1
+ fi
+ done
+ return 0
}
python_configure_all() {
+ local cpu_baseline=()
+ local map flag
+ case ${ARCH} in
+ arm)
+ # every flag implies the previous one
+ for map in NEON:neon NEON_FP16:neon-fp16 NEON_VFPV4:vfpv4; do
+ if ! use "cpu_flags_arm_${map#*:}"; then
+ break
+ fi
+ cpu_baseline+=( "${map%:*}" )
+ done
+ ;&
+ arm64)
+ # on 32-bit ARM, ASIMD implies all NEON* flags
+ # on 64-bit ARM, they are all linked together
+ if use arm64 ||
+ [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == NEON_VFPV4 ]]
+ then
+ cpu_baseline+=( $(usev cpu_flags_arm_asimd ASIMD) )
+ fi
+
+ # these two imply ASIMD
+ if [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == ASIMD ]]; then
+ for flag in dp hp; do
+ cpu_baseline+=(
+ $(usev "cpu_flags_arm_asimd${flag}" "ASIMD${flag^^}")
+ )
+ done
+ fi
+
+ # these two imply ASIMDHP
+ if [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == ASIMDHP ]]; then
+ for flag in asimdfhm sve; do
+ cpu_baseline+=(
+ $(usev "cpu_flags_arm_${flag}" "${flag^^}")
+ )
+ done
+ fi
+ ;;
+ ppc64)
+ # every flag implies the previous one
+ for flag in '' 2 3 4; do
+ if ! use "cpu_flags_ppc_vsx${flags}"; then
+ break
+ fi
+ cpu_baseline+=( "VSX${flag}" )
+ done
+ ;;
+ amd64|x86)
+ # every flag implies the previous one
+ for flag in sse{,2,3} ssse3 sse4_1 popcnt sse4_2 avx; do
+ if ! use "cpu_flags_x86_${flag}"; then
+ break
+ fi
+ flag=${flag/_}
+ cpu_baseline+=( "${flag^^}" )
+ done
+
+ # these imply AVX
+ if [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == AVX ]]; then
+ for flag in xop fma4 f16c; do
+ if use "cpu_flags_x86_${flag}"; then
+ cpu_baseline+=( "${flag^^}" )
+ fi
+ done
+ fi
+
+ # another chain started on implying F16C
+ if [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == F16C ]]; then
+ for flag in fma3 avx2 avx512f avx512cd; do
+ if ! use "cpu_flags_x86_${flag}"; then
+ break
+ fi
+ cpu_baseline+=( "${flag^^}" )
+ done
+ fi
+
+ if [[ ${cpu_baseline[@]} && ${cpu_baseline[-1]} == AVX512CD ]]; then
+ # upstream combines multiple instructions into per-CPU sets
+ local -A avx512_mapping=(
+ [AVX512_KNL]="avx512pf avx512er"
+ [AVX512_KNM]="avx512_vpopcntdq avx512_4vnniw avx512_4fmaps"
+ [AVX512_SKX]="avx512dq avx512bw avx512vl"
+ [AVX512_CLX]="avx512_vnni"
+ [AVX512_CNL]="avx512ifma avx512vbmi"
+ [AVX512_ICL]="avx512_vbmi2 avx512_bitalg"
+ [AVX512_SPR]="avx512_fp16"
+ )
+
+ # 1. AVX512CD -> AVX512_KNL -> AVX512_KNM
+ if has_all_x86 ${avx512_mapping[AVX512_KNL]}; then
+ cpu_baseline+=( AVX512_KNL )
+ if has_all_x86 ${avx512_mapping[AVX512_KNM]}; then
+ cpu_baseline+=( AVX512_KNM )
+ fi
+ fi
+ # 2. AVX512CD -> AVX512_SKX -> [AVX512_CLX, AVX512_CNL]
+ if has_all_x86 ${avx512_mapping[AVX512_SKX]}; then
+ cpu_baseline+=( AVX512_SKX )
+ if has_all_x86 ${avx512_mapping[AVX512_CLX]}; then
+ cpu_baseline+=( AVX512_CLX )
+ fi
+ if has_all_x86 ${avx512_mapping[AVX512_CNL]}; then
+ cpu_baseline+=( AVX512_CNL )
+ fi
+ fi
+ # 3. [AVX512_CLX, AVX512_CNL] -> AVX512_ICL -> AVX512_SPR
+ if [[ ${cpu_baseline[-1]} == AVX512_CNL &&
+ ${cpu_baseline[-2]} == AVX512_CLX ]]
+ then
+ if has_all_x86 ${avx512_mapping[AVX512_ICL]}; then
+ cpu_baseline+=( AVX512_ICL )
+ if has_all_x86 ${avx512_mapping[AVX512_SPR]}; then
+ cpu_baseline+=( AVX512_SPR )
+ fi
+ fi
+ fi
+ fi
+ ;;
+ *)
+ cpu_baseline=MIN
+ ;;
+ esac
+
DISTUTILS_ARGS=(
-Dallow-noblas=$(usex !lapack true false)
-Dblas=$(usev lapack cblas)
-Dlapack=$(usev lapack lapack)
- # TODO: cpu-* options
+ -Dcpu-baseline="${cpu_baseline[*]}"
+ -Dcpu-baseline-detect=disabled
+ # '-XOP -FMA4' is upstream default, since these are deprecated
+ -Dcpu-dispatch="$(usev cpudetection 'MAX -XOP -FMA4')"
)
+
+ # bug #922457
+ filter-lto
+ # https://github.com/numpy/numpy/issues/25004
+ append-flags -fno-strict-aliasing
}
python_test() {
@@ -97,6 +241,11 @@ python_test() {
numpy/_core/tests/test_umath_accuracy.py::TestAccuracy::test_validate_transcendentals
numpy/typing/tests/test_typing.py
+
+ # Flaky, reruns don't help
+ numpy/f2py/tests/test_crackfortran.py
+ numpy/f2py/tests/test_f2py2e.py::test_gh22819_cli
+ numpy/f2py/tests/test_data.py::TestData{,F77}::test_crackedlines
)
if [[ $(uname -m) == armv8l ]]; then
@@ -190,9 +339,8 @@ python_test() {
)
fi
- local -x PYTEST_DISABLE_PLUGIN_AUTOLOAD=1
cd "${BUILD_DIR}/install$(python_get_sitedir)" || die
- epytest -p rerunfailures --reruns=5
+ epytest
}
python_install_all() {